
#pragma once

#include <ostream>
#include <istream>

using namespace std;

class V3 {
public:
	float xyz[3];
	V3() {};
	V3(float x, float y, float z);
	float& operator[](int i);
	V3 operator+(V3 op1);
	V3 operator-(V3 op1);
	float operator*(V3 op1);
	V3 operator*(float scf);
	V3 operator/(float scf);
	V3 operator^(V3 op1);
	friend ostream& operator<<(ostream& ostr, V3 v);
	unsigned int GetColor();
	V3 RotateThisPointAboutAxis(V3 aO, V3 aD, float theta);
	V3 RotateThisVectorAboutAxis(V3 aD, float theta);
	float Length();
	V3 UnitVector();
};
